<?php

/**
 * @file Contains functions to build the settings page.
 */

/**
 * Renders the settings form.
 */
function robotagger_api_settings_page() {
  $output = '';
  $form = drupal_get_form('robotagger_api_settings_form');
  $output .= drupal_render($form);
  return $output;
}

/**
 * Build the settings form.
 *
 * @param array $form
 * @param array $form_state
 *
 * @return system_settings_form().
 */
function robotagger_api_settings_form($form, $form_state) {
  $form['robotaggerapi_server'] = array(
    '#type' => 'textfield',
    '#title' => t('RoboTagger server host'),
    '#default_value' => Robotagger::gethost(),
    '#required' => TRUE,
  );
  $form['robotaggerapi_server_apikey'] = array(
    '#type' => 'textfield',
    '#title' => t('RoboTagger server api-key'),
    '#default_value' => variable_get('robotaggerapi_server_apikey', ''),
    '#required' => TRUE,
  );
  return system_settings_form($form);
}

/**
 * Validates the submitted api-key.
 *
 * @param array $form
 * @param array $form_state
 */
function robotagger_api_settings_form_validate($form, $form_state) {
  if (robotagger_api_validate_api_key($form_state['values']['robotaggerapi_server_apikey'], $form_state['values']['robotaggerapi_server']) != 1) {
    return form_set_error('robotaggerapi_server_apikey', t('Your RoboTagger api-key is not valid.'));
  }
}